<html>
<head>

<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.6/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>
<!--<script type="text/javascript" src="MathJax/MathJax.js?config=TeX-AMS-MML_HTMLorMML"></script>-->
<script type="text/javascript" src="jquery-1.10.2.js"></script>
<script type="text/javascript" src="calculationlib/matrixlib.js"></script>
<script type="text/javascript" src="calculationlib/polynomial.js"></script>
<script type="text/javascript" src="calculationlib/mathhelper.js"></script>

<style>
.edit-text {
  display: none;
}
.label-g .mathtex {
  float: left;
}
.mathtex {
  padding: 5px;
}
td {
  padding: 5px;
}
</style>

<script>







var CreateInput = function(inputCount) {

  var text = "<hr><h3>Sırrı Çözme</h3>";
  text += "<div id='divFindSecretParams'>";
  text += "<div id='divSecretInputs'>";
  text += "<table>"
  text += "<tr>";
  for (var i = 1; i < inputCount+1; i++)
    text += "<td align='center'>" + i + "</td>";
  text += "</tr>";
  text += "<tr>";
  for (var i = 1; i < inputCount+1; i++)
    //text += "<td><input type='text' style='text-align:center;' maxlength='4' size='4' num=" + i + " id='txtInpt" + i + "' /></td>";
    text += "<td><textarea rows='15' size='15' num=" + i + " id='txtInpt" + i + "'></textarea></td>";

  text += "</tr>";
  text += "</table>";
  text += "</div>";
  text += "<input type='button' class='findscrt' id='btnFindSecret' value='Sırrı Bul' />";
  text += "</div>";
  text += "<div id='divSecretResult'> </div>";
  return text;
}
var FieldExtend = function(gp){
  $this = this;
  $this.GenPoly = gp;
  $this.GenPolyPow = gp.Data.length - 1;
  $this.Root = new Polynomial(gp.Data.slice(1), gp.Degree, "\\theta").Multiply(gp.Degree.Inverse(gp.Data[0]), "\\theta");
  $this.Degree = gp.Degree;

  var generatePolynomPow = function(p, c) {
      var data = [];
      c = c || 1;
      data.push(c);
      for (var i = 0; i < p; i++)
        data.push(0);
      return new Polynomial(data, gp.Degree, "\\theta");
    }
  var reduce = function(poly, rootDegree, root) { // x^255, 8, \\theta+1
      if (poly.Data.length - 1 < rootDegree)
        return poly;
      var lowerPart = new Polynomial(poly.Data.slice(poly.Data.length - rootDegree, poly.Data.length), gp.Degree, "\\theta");
      var list = [lowerPart];
      for (var i = 0; i < poly.Data.length - rootDegree; i++){
        var pw = poly.Data.length - i - 1;
        var r = pw % rootDegree;
        var b = parseInt(pw / rootDegree);
        if (poly.Data[i] == 0)
          continue;
		    var coef = poly.Data[i];
        var rp = generatePolynomPow(r);
        var resp = root.Pow(b, "\\theta").Multiply(coef, "\\theta").Multiply(rp, "\\theta");
        if (resp.Data.length - 1 >= rootDegree)
          resp = reduce(resp, rootDegree, root);
        list.push(resp);
      }
      var result = new Polynomial([0], gp.Degree, "\\theta" );
      for (var i = 0; i < list.length; i++) {
        result = result.Add(list[i], "\\theta");
      }
      if (result.Data.length - 1 >= rootDegree)
        result = reduce(result, rootDegree, root);
      return result;
    }
  $this.Get = function(pow) {
    var poly = generatePolynomPow(pow);
    return poly;
  }
  $this.GetElementPow = function(pow) {
    var poly = generatePolynomPow(pow);
    poly = reduce(poly, this.GenPolyPow, this.Root);
    return poly;
    //var r = pow % $this.GenPolyPow;
    //var b = parseInt(pow / $this.GenPolyPow);
    //return { Text: (b > 0 ? "(" + $this.Root.Text + ")^{" + b + "}" : "") + (r > 0 ?" \\theta^{" + r + "}" : "")   };
    return this.Root.Pow(2, "\\theta");
  }
  $this.Reduce = function(poly) {
	  return reduce(poly, this.GenPolyPow, this.Root);
  }
};


var TransferFunction = function(fieldExtend) {
  $this = this;
  $this.Field = fieldExtend;
  $this.Level = Math.pow(this.Field.Degree.Value, this.Field.GenPolyPow);



  $this.Info = function(){
    var transferfunction =
      'T(x) =' +
      '\\left\\{' +
      '\\begin{array}{ll}' +
      '0,        & x \\equiv 0 \\pmod{' + $this.Level + '} \\text{ ise} \\\\' +
      '\\theta^x, & x \\not\\equiv 0 \\pmod{' + $this.Level + '} \\text{ ise}' +
      '\\end{array}' +
      '\\right.';
    return transferfunction;
  }
  $this.Get = function(value){
    var val = value % this.Level;
    if (val == 0)
      return new Polynomial([0], this.Field.Degree, "\\theta");
    return this.Field.Get(val);
  }
  $this.Calc = function(value){
    var val = value % this.Level;
    var arr = val.toString(2).padStart(8, '0').split('').map(function(a) { return parseInt(a);})
    return new Polynomial(arr, this.Field.Degree, "\\theta");
    //if (val == 0)
    //  return new Polynomial([0], this.Field.Degree, "\\theta");
    //return this.Field.GetElementPow(val);
  }
  $this.Text = function(value){
    var val = value % this.Level;
    return '\\theta^{' + val + '}';
  }

  //trf.Calc(1).Data.toString() == trf.Calc(1).Data.toString()
  var data = {};
  var reverse = {};
  for (var i = 0; i < $this.Level; i++) {
    var val = $this.Calc(i);
    data[i] = val;
    reverse[val.Data.toString()] = i;
  }

  $this.Reverse = function(polynom){
    return reverse[polynom.Data.toString()];
  }
};


var Divide = function(a, b) {

  var degree = a.Degree;
  var pow = degree.Value;

  k = a.Data.length - b.Data.length;
  if (k < 0) {
    return new Polynomial([0], pow, a.Symbol);
  }

  var result = Array(k+1).fill(0);

  for (var i = 0; i < result.length; i++){
    var pos = result.length - i - 1;
    var f1 = a.Data[0];
    var f2 = b.Data[0];
    var val =  degree.Inverse(f2) * f1;
    result[pos] = val;
    var coef = degree.Inverse(val);
    var c = a.Add(new Polynomial(b.Data.concat(Array(k).fill(0)), pow, a.Symbol));
    a = c;
  }
  return new Polynomial(result, pow, a.Symbol);
}

// dx, s(x), t(x)   g(x)s(x) + h(x)t(x) = d(x)
var ExtendedEuclid = function(gx, hx){

  var degree = gx.Degree;
  var base = degree.Value;
  var symbol = gx.Symbol;

  var sx = new Polynomial([0], base, symbol);
  var tx = new Polynomial([0], base, symbol);
  var s1x = new Polynomial([0], base, symbol);
  var s2x = new Polynomial([1], base, symbol);
  var t1x = new Polynomial([1], base, symbol);
  var t2x = new Polynomial([0], base, symbol);

  while (!(hx.Data.length == 1 && hx.Data[0] == 0))
  {
    var qx = Divide(gx, hx);
    var rx = gx.Add(qx.Multiply(hx).Multiply(-1));
    sx = s2x.Add(qx.Multiply(s1x).Multiply(-1));
    tx = t2x.Add(qx.Multiply(t1x).Multiply(-1));
    gx = hx;
    hx = rx;
    s2x = s1x;
    s1x = sx;
    t2x = t1x;
    t1x = tx;
  }
  return [gx, s2x, t2x];
}
var ExtendedEuclidInverse = function(gx, hx){
  var res = ExtendedEuclid(gx, hx);
  var dx = res[0];
  if (dx.Data.length == 1 && dx.Data[0] == 1){
    return res[2];
  }
}

var CreateImage = function(matrix){
  var width = matrix.ColCount,
      height = matrix.RowCount,
      buffer = new Uint8ClampedArray(width * height * 4); // have enough bytes

  for(var y = 0; y < height; y++) {
    for(var x = 0; x < width; x++) {
      var pos = (y * width + x) * 4; // position in buffer based on x and y
      var val = matrix.Get(y, x);
      buffer[pos  ] = val;           // some R value [0, 255]
      buffer[pos+1] = val;           // some G value
      buffer[pos+2] = val;           // some B value
      buffer[pos+3] = 255;           // set alpha channel
    }
  }
  //var canvas = $('<canvas/>');
  var canvas = document.createElement('canvas'),
  ctx = canvas.getContext('2d');
  canvas.width = width;
  canvas.height = height;
  var idata = ctx.createImageData(width, height); // create imageData object
  idata.data.set(buffer);        // set our buffer as source
  ctx.putImageData(idata, 0, 0); // update canvas with new data
  return canvas;
}

var Copy = function(text) {
  var copyFrom = $('<textarea/>');
  copyFrom.css({
   position: "absolute",
   left: "-1000px",
   top: "-1000px",
  });
   copyFrom.text(text);
   $('body').append(copyFrom);
   copyFrom.select();
   document.execCommand('copy');
}

var mthhlp = new mathhelper();
var fld;
var trf;
var shareMatrixes = [];
var imageMatrix;

$(document).ready(function() {
  $('a.edit').click(function() {
    var t = $(this).parent();  // div
	  var l = t.find('.lab');    // label
    var value = l.attr("data-value").trim();
    l.hide();
    t.find('.edit').hide();
	  t.find('.edit-text').show().focus().val(value);
  });
  $('.label-g .edit-text').focusout(function() {
    var t = $(this).parent();
	  $(this).hide();
    var mode = $(this).attr("value-mode");
    var deg = parseInt(eval($(this).attr("data-degree")));
    var l = t.find('.lab');

    var raw =  $(this).val();
    var result = raw;
    if (mode == "polynom") {
      var data = mthhlp.read.polynomial(raw);
      var poly = new Polynomial(data, deg);
      result = poly.Text;
      $(this).attr("data-polynom", poly);
    }
    else if (mode == "matrix") {
      var data = mthhlp.read.matrix(raw);
      var matrix = new Matrix(data);
      result = matrix.ToLatex();
      $(this).attr("data-matrix", matrix);
    }
    l.attr("data-value", raw);
    mthhlp.out.clear(l);
    mthhlp.out.write(l, result);
    l.show();
    t.find('.edit').show();
  });
  $('.label-g .edit-text').trigger('focusout');

  $('#elDegree .edit-text').on('focusout', function() {
	   $('#elPolynomial .edit-text').trigger('focusout');
  });
  $('#btnCalculateField').on('click', function() {
    shareMatrixes = [];
    var degree = parseInt($("#elDegree .edit-text").val());
    var genPoly = new Polynomial(mthhlp.read.polynomial($("#elPolynomial .edit-text").val()), degree);
    var fieldExtend = new FieldExtend(genPoly);
    fld = fieldExtend;


    var n = parseInt($("#elN .edit-text").val());
    var k = parseInt($("#elK .edit-text").val());
    var s = parseInt($("#elSecret .edit-text").val());

    var imageText = $("#mtImage .edit-text").val();
    var imageArray = mthhlp.read.matrix(imageText);
    var imageMatrix = new Matrix(imageArray);


    var result = $("#result");

    mthhlp.out.clear(result);


    var canvas = CreateImage(imageMatrix);
    result.append(canvas);

    mthhlp.out.write(result, "f(x) = " + genPoly.Text);
    mthhlp.out.write(result, " ");

    mthhlp.out.write(result, "\\theta^{" + fieldExtend.GenPolyPow + "}=" + fieldExtend.Root.Text);
    mthhlp.out.write(result, " ");

    var level = Math.pow(fieldExtend.Degree.Value, fieldExtend.GenPolyPow);
    var tf = new TransferFunction(fieldExtend);
    trf = tf;

    var newWith = Math.ceil(imageMatrix.ColCount / (k-1));
    var newHeight = imageMatrix.RowCount;
    mthhlp.out.write(result, "w' = " + newWith);   mthhlp.out.write(result, " ");
    mthhlp.out.write(result, "h' = " + newHeight); mthhlp.out.write(result, " ");

    var coeficients = [2, 8, 64, 128, 1, 8, 16, 128, 28, 196, 57, 59, 1, 159, 56, 244, 209, 170];

    var polynomials = Array(newHeight).fill(0).map(x => Array(newWith));
    for (var y = 0; y < newHeight; y++){
      for (var x = 0; x < newWith; x++){
        var array = Array(k).fill(0);
        while (array[0] == 0)
          array[0] = parseInt(coeficients[y * newWith  + x]);
        for (var ii = 0; ii < k-1; ii++){
          //array[k-1-ii] = imageMatrix.Get(y, x * (k-1) + ii);
          var pos = x * (k-1) + ii;
          array[ii+1] = pos < imageMatrix.ColCount ? imageMatrix.Get(y, pos) : 255;
        }
        var polynomial = new Polynomial(array);;
        polynomials[y][x] = polynomial;
      }
    }

    var pxtext =
    polynomials.reduce(function(total, currentValue, currentIndex, arr) {
      var val = currentValue.reduce(function(total1, currentValue1, currentIndex1, arr1){
        return total1 + "(" + currentValue1.Text + ")" + "&";
      }, "");
      return total + val.substring(0, val.length-1) + "\\\\";
    }, "");
    mthhlp.out.write(result, "P(x) = \\begin{bmatrix}" + pxtext + "\\end{bmatrix}");
    mthhlp.out.write(result, " ");


    var polyInGFq =
    polynomials.map(function(currentValue, index, arr){
      return currentValue.map(function(currentValue1, index1, arr1){
        var polyarray = [];
        for (var i = 0; i < currentValue1.Data.length; i++){
          polyarray.push(tf.Calc(currentValue1.Data[i]));
        }
        var poly = new Polynomial(polyarray);
        return poly;
      })
    });

    var pxtext =
    polyInGFq.reduce(function(total, currentValue, currentIndex, arr) {
      var val = currentValue.reduce(function(total1, currentValue1, currentIndex1, arr1){
        return total1 + "(" + currentValue1.Text + ")" + "&";
      }, "");
      return total + val.substring(0, val.length-1) + "\\\\";
    }, "");
    mthhlp.out.write(result, "T(x) = \\begin{bmatrix}" + pxtext + "\\end{bmatrix}");
    mthhlp.out.write(result, " ");

    var pxtext2 =
    polyInGFq.reduce(function(total, currentValue, currentIndex, arr) {
      var val = currentValue.reduce(function(total1, currentValue1, currentIndex1, arr1){
        return total1 + "t_{" + (currentIndex+1) + "" + (currentIndex1+1) + "}(x) = & "  + currentValue1.Text + "\\\\";
      }, "");
      return total + val;
    }, "");
    mthhlp.out.write(result, "\\begin{array}{ll}" + pxtext2 + "\\end{array}");
    mthhlp.out.write(result, " ");


    for (var i = 1; i <= n; i++){
      var id = trf.Calc(i);
      var piarray =
      polyInGFq.map(function(currentValue, index, arr){
        return currentValue.map(function(currentValue1, index1, arr1){
          return trf.Reverse(fieldExtend.Reduce(currentValue1.Calculate(id)));
        })
      });
      var shareMatrix = new Matrix(piarray);
      mthhlp.out.write(result, "T(" + i + ") = " + shareMatrix.ToLatex());
      shareMatrixes.push(shareMatrix);
      var canvas = CreateImage(shareMatrix);
      result.append(canvas);
      result.append($("<input  style='margin: 5' type='button' value='Kopyala' onclick='Copy(shareMatrixes[" + (i-1) + "].ToString2())'/>"));
      mthhlp.out.write(result, " ");
    }

    mthhlp.out.write(result, " ");
    mthhlp.out.write(result, " ");
    mthhlp.out.write(result, " ");


    var inputs = CreateInput(n);
    $("#reconstuct").html(inputs);
    $('.findscrt').on('click', function() {
      var findresult = $("#divSecretResult");
      //$("#divSecretResult").append("<h4>Birinci Yöntem</h4>");
      var text1 = "L(x)=\\sum_{j=0}^{k}{y_jl_j(x)} \\\\ ";
      //text1 += "l_j(x)=\\prod_{\\begin{array}{c}0 \\leq m \\leq k \\\\ m \\neq j \\end{array}}{\\frac{x-x_m}{x_j-x_m}}";
      text1 += "l_j(x)=\\prod_{\\begin{array}{c}0 \\leq m \\leq k \\\\ m \\neq j \\end{array}}{\\frac{x-x_m}{x_j-x_m}}";
      mthhlp.out.clear(findresult);
      mthhlp.out.write(findresult, text1);
      mthhlp.out.write(findresult, "");

      var pairs = [];
      $("[id^=txtInpt]").each(function() {
        if (!isNaN(parseInt($(this).val())))
          pairs.push([parseInt($(this).attr('num')), new Matrix(mthhlp.read.matrix($(this).val()))]);
      });

      var width = pairs[0][1].ColCount;
      var height = pairs[0][1].RowCount;

      var polynomials = Array(height).fill(0).map(x => Array(width));
      //var polynomials = Array(height).fill(0).map(function(x,i)
      for (var i = 0; i < height; i++)
      {
        //return Array(width).fill(0).map(function(y,j)
        for (var j = 0; j < width; j++)
        {
          var L = [];
          for (var k = 0; k < pairs.length; k++){
            var polyarray = [ new Polynomial([1], fieldExtend.Degree, "\\theta") ];
            var polynom = new Polynomial(polyarray)
            for (var t = 0; t < pairs.length; t++) {
              if (k == t) continue;
              var xk = tf.Calc(pairs[k][0]);
              var xt = tf.Calc(pairs[t][0]);
              var divider = xk.Add(xt.Multiply(-1));

              var genPoly2 = new Polynomial(genPoly.Data, genPoly.Degree, "\\theta");
              var inverse = ExtendedEuclidInverse(genPoly2, divider);

              var subpolyarray =
              [
                new Polynomial([1], fieldExtend.Degree, "\\theta"),
                xt.Multiply(-1)
              ];
              var p = new Polynomial(subpolyarray);
              p = p.Multiply(inverse);
              polynom = polynom.Multiply(p);
              var reducedarray = [];
              for (var b = 0; b < polynom.Data.length; b++)
                reducedarray.push(fieldExtend.Reduce(polynom.Data[b]));
              polynom = new Polynomial(reducedarray);
            }
            L.push(polynom);
          }
          var result = new Polynomial([new Polynomial([0], fieldExtend.Degree, "\\theta")]);
          for (var t = 0; t < L.length; t++) {
            var val = tf.Calc(pairs[t][1].Get(i, j));
            var mp = L[t].Multiply(val);
            var reducedarray = [];
            for (var b = 0; b < mp.Data.length; b++)
              reducedarray.push(fieldExtend.Reduce(mp.Data[b]));
            mp = new Polynomial(reducedarray);
            result = result.Add(mp);
          }

          var reducedarray = [];
          for (var b = 0; b < result.Data.length; b++)
            reducedarray.push(fieldExtend.Reduce(result.Data[b]));
          result = new Polynomial(reducedarray);

          polynomials[i][j] = result;
        }
      };

      var pxtext =
      polynomials.reduce(function(total, currentValue, currentIndex, arr) {
        var val = currentValue.reduce(function(total1, currentValue1, currentIndex1, arr1){
          return total1 + "(" + currentValue1.Text + ")" + "&";
        }, "");
        return total + val.substring(0, val.length-1) + "\\\\";
      }, "");
      mthhlp.out.write(findresult, "P(x) = \\begin{bmatrix}" + pxtext + "\\end{bmatrix}");
      mthhlp.out.write(findresult, " ");


      var polyInZq =
      polynomials.map(function(currentValue, index, arr){
        return currentValue.map(function(currentValue1, index1, arr1){
          var polyarray = [];
          for (var i = 0; i < currentValue1.Data.length; i++){
            polyarray.push(tf.Reverse(currentValue1.Data[i]));
          }
          var poly = new Polynomial(polyarray);
          return poly;
        })
      });

      var pxtext =
      polyInZq.reduce(function(total, currentValue, currentIndex, arr) {
        var val = currentValue.reduce(function(total1, currentValue1, currentIndex1, arr1){
          return total1 + "(" + currentValue1.Text + ")" + "&";
        }, "");
        return total + val.substring(0, val.length-1) + "\\\\";
      }, "");
      mthhlp.out.write(findresult, "P(x) = \\begin{bmatrix}" + pxtext + "\\end{bmatrix}");
      mthhlp.out.write(findresult, " ");


      var image =
      polyInZq.map(function(currentValue, index, arr){
        //var size = (currentValue[0].Data.length-1) * currentValue.length;
        var line = [];
        for (var i = 0; i < currentValue.length; i++){
          var der = currentValue[i].Data.length;
          for (var j = 0; j < der-1; j++){
            line[i * (der-1) + j] = currentValue[i].Data[j+1];
          }
        }
        return line;
      });

      var imageMatrix = new Matrix(image);
      mthhlp.out.write(findresult, "I = " + imageMatrix.ToLatex());

      var canvas = CreateImage(imageMatrix);
      findresult.append(canvas);
      findresult.append($("<input  style='margin: 5' type='button' value='Kopyala' onclick='Copy(imageMatrix.ToString2())'/>"));
      mthhlp.out.write(findresult, " ");



    })
  });

});

</script>

</head>
<body>


<table>
  <tr>
    <td>
      <label for="label-g" style="float:left; padding-right:4px;">Cisim Derecesi (\(q\)): </label>
    </td>
    <td>
      <div class="label-g" id="elDegree">
        <label for="elab" class="lab"></label>
        <input type="text" id = "elab" class="edit-text" value = "2" />
        <a class="edit" href="#" style="padding-left:5px"> Düzenle </a>
      </div>
    </td>
  </tr>

  <tr>
    <td>
      <label for="label-g" style="float:left; padding-right:4px;">Üreteç Polinom (\(f(x)\)): </label>
    </td>
    <td>
      <div class="label-g" id="elPolynomial">
        <label for="elab" class="lab"></label>
        <input type="text" id = "elab" class="edit-text" value="x^8 +x^4+x^3+x^2+1" value-mode="polynom" data-degree="$('#elDegree .edit-text').val()"/>
        <a class="edit" href="#" style="padding-left:5px"> Düzenle </a>
      </div>
    </td>
  </tr>

  <tr>
    <td>
      <label for="label-g" style="float:left; padding-right:4px;">Katılımcı Sayısı (\(n\)): </label>
    </td>
    <td>
      <div class="label-g" id="elN">
        <label for="elab" class="lab"></label>
        <input type="text" id = "elab" class="edit-text" value = "5" />
        <a class="edit" href="#" style="padding-left:5px"> Düzenle </a>
      </div>
    </td>
  </tr>

  <tr>
    <td>
      <label for="label-g" style="float:left; padding-right:4px;">Eşik Değeri (\(k\)): </label>
    </td>
    <td>
      <div class="label-g" id="elK">
        <label for="elab" class="lab"></label>
        <input type="text" id = "elab" class="edit-text" value = "3" />
        <a class="edit" href="#" style="padding-left:5px"> Düzenle </a>
      </div>
    </td>
  </tr>

  <tr style="display:none">
    <td>
      <label for="label-g" style="float:left; padding-right:4px;">Sır (\(s\)): </label>
    </td>
    <td>
      <div class="label-g" id="elSecret">
        <label for="elab" class="lab"></label>
        <input type="text" id = "elab" class="edit-text" value = "150" />
        <a class="edit" href="#" style="padding-left:5px"> Düzenle </a>
      </div>
    </td>
  </tr>

  <tr>
    <td>
      <label for="label-g" style="float:left; padding-right:4px;">Resim (\(I\)): </label>
    </td>
    <td>
      <div class="label-g" id="mtImage">
      <label for="elab" class="lab"></label>
      <textarea class="edit-text" id = "elab" rows="5" value-mode="matrix" data-degree="2">
254 241 189 189 241 254
254 189 254 254 189 254
197 210 210 210 210 197
178 192 209 209 192 178
172 186 196 196 186 172
157 168 168 168 168 157
      </textarea>
      <a class="edit" href="#" style="padding-left:5px"> Düzenle </a>
      </div>
    </td>
  </tr>
</table>

<input type="button" id="btnCalculateField" value="Hesapla" />

<div id="result"  style="padding: 20px"> </div>

<div id="reconstuct" style="padding: 20px"> </div>


</body>
</html>
